Matcher (Hamcrest)
Date: 2012-07-09

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hamcrest
Interface Matcher<T>

All Superinterfaces:
  SelfDescribing

All Known Implementing Classes:
  AllOf, AnyOf, BaseMatcher, BigDecimalCloseTo, CombinableMatcher, CustomMatcher, CustomTypeSafeMatcher, DescribedAs, DiagnosingMatcher, Every, FeatureMatcher, HasProperty, HasPropertyWithValue, HasToString, HasXPath, Is, IsAnything, IsArray, IsArrayContaining, IsArrayContainingInAnyOrder, IsArrayContainingInOrder, IsArrayWithSize, IsCloseTo, IsCollectionContaining, IsCollectionWithSize, IsCompatibleType, IsEmptyCollection, IsEmptyIterable, IsEmptyString, IsEqual, IsEqualIgnoringCase, IsEqualIgnoringWhiteSpace, IsEventFrom, IsIn, IsInstanceOf, IsIterableContainingInAnyOrder, IsIterableContainingInOrder, IsIterableWithSize, IsMapContaining, IsNot, IsNull, IsSame, OrderingComparison, SamePropertyValuesAs, SamePropertyValuesAs.PropertyMatcher, StringContains, StringContainsInOrder, StringEndsWith, StringStartsWith, SubstringMatcher, TypeSafeDiagnosingMatcher, TypeSafeMatcher

    public interface Matcher<T>

extends SelfDescribing

A matcher over acceptable values. A matcher is able to describe itself to give feedback when it fails.

Matcher implementations should NOT directly implement this interface. Instead, extend the `BaseMatcher` abstract class, which will ensure that the Matcher API can grow to support new features and remain compatible with all Matcher implementations.

For easy access to common Matcher implementations, use the static factory methods in `CoreMatchers`.

N.B. Well designed matchers should be immutable.

See Also:
  `CoreMatchers`, `BaseMatcher`

Method Summary
`void` | `_dont_implement_Matcher___instead_extend_BaseMatcher_()` Deprecated. to make
`void` | `describeMismatch(java.lang.Object item, Description mismatchDescription)` Generate a description of why the matcher has not accepted the item.
`boolean` | `matches(java.lang.Object item)` Evaluates the matcher for argument item.

Methods inherited from interface org.hamcrest.SelfDescribing
`describeTo`

Method Detail

### matches

    boolean matches(java.lang.Object item)

  Evaluates the matcher for argument item.

  This method matches against Object, instead of the generic type T. This is because the caller of the Matcher does not know at runtime what the type is (because of type erasure with Java generics). It is down to the implementations to check the correct type.

  Parameters:
    `item` - the object against which the matcher is evaluated.
  Returns:
    `true` if item matches, otherwise `false`.
  See Also:
    `BaseMatcher`

### describeMismatch

    void describeMismatch(java.lang.Object item,
                          Description mismatchDescription)

  Generate a description of why the matcher has not accepted the item. The description will be part of a larger description of why a matching failed, so it should be concise. This method assumes that `matches(item)` is false, but will not check this.

  Parameters:
    `item` - The item that the Matcher has rejected.
    `mismatchDescription` - The description to be built or appended to.

### _dont_implement_Matcher___instead_extend_BaseMatcher_

    @Deprecated
    void _dont_implement_Matcher___instead_extend_BaseMatcher_()

  Deprecated. to make

  This method simply acts a friendly reminder not to implement Matcher directly and instead extend BaseMatcher. It's easy to ignore JavaDoc, but a bit harder to ignore compile errors .

  See Also:
    `for reasons why.`, `BaseMatcher`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD